﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
namespace pac8172WNet
{
    public class pac8172W
    {
        private class ICPDAS
        {
            // function for I-8172
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_GetLibVersion")]
            public static extern Int16 pac_i8172W_GetLibVersion();
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_GetLibDate")]
            public static extern void pac_i8172W_GetLibDate(byte[] libDate);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_Init")]
            public static extern Int16 pac_i8172W_Init(int Slot);
            // function for I-8172 to FR-2057
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_WriteDOGroup")]
            public static extern void pac_i8172W_WriteDOGroup(int iSlot, int iPort, int iGroup, UInt16 iData);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_WriteDOBit")]
            public static extern void pac_i8172W_WriteDOBit(int iSlot, int iPort, int iGroup, int iChannel, int iStatus);
            // function for I-8172 to FR-2053
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_ReadDIGroup")]
            public static extern UInt16 pac_i8172W_ReadDIGroup(int iSlot, int iPort, int iGroup);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_ReadDIBit")]
            public static extern UInt16 pac_i8172W_ReadDIBit(int iSlot, int iPort, int iGroup, int iChannel);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_ReadInputGroupStatus")]
            public static extern Int16 pac_i8172W_ReadInputGroupStatus(int iSlot, int iPort, int iGroup);
            // function for I-8172 to FR-2054
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_DIO_WriteDOGroup")]
            public static extern void pac_i8172W_DIO_WriteDOGroup(int iSlot, int iPort, int iGroup, UInt16 iData);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_DIO_WriteDOBit")]
            public static extern void pac_i8172W_DIO_WriteDOBit(int iSlot, int iPort, int iGroup, int iChannel, int iStatus);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_DIO_ReadDIGroup")]
            public static extern UInt16 pac_i8172W_DIO_ReadDIGroup(int iSlot, int iPort, int iGroup);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_DIO_ReadDIBit")]
            public static extern UInt16 pac_i8172W_DIO_ReadDIBit(int iSlot, int iPort, int iGroup, int iChannel);
            // function for I-8172 to FR-2017
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_ReadAIHex")]
            public static extern Int16 pac_i8172W_ReadAIHex(int iSlot, int iPort, int iGroup, short bitMode, ref short iChannel, ref short aiHex);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_AIHexToFloat")]
            public static extern void pac_i8172W_AIHexToFloat(Int16 hexData, Int16 typeCode, Int16 bitMode, ref float fData);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_ReadAI_Ch")]
            public static extern Int16 pac_i8172W_ReadAI_Ch(int iSlot, int iPort, int iGroup, short bitMode, short typeCode, short iChannel, ref float aiFloat);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_ReadAI_All")]
            public static extern Int16 pac_i8172W_ReadAI_All(int iSlot, int iPort, int iGroup, short bitMode, short isSingleEnded, short[] typeCode, float[] aiFloat);
            // function for I-8172 to FR-2024
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_WriteAOHex")]
            public static extern Int16 pac_i8172W_WriteAOHex(int iSlot, int iPort, int iGroup, short bitMode, short iChannel, short aoHexData, short ifDelay);
            [DllImport("pac_i8172W_UWP_x64.dll", EntryPoint = "pac_i8172W_WriteAOFloat")]
            public static extern Int16 pac_i8172W_WriteAOFloat(int iSlot, int iPort, int iGroup, short bitMode, short iChannel, short typeCode, float aoFloat, short ifDelay);
        }
        public static Int16 LibVersion()
        {
            return ICPDAS.pac_i8172W_GetLibVersion();
        }
        public static string LibDate()
        {
            byte[] libDate = new byte[32];
            ICPDAS.pac_i8172W_GetLibDate(libDate);
            return AscArr2Str(libDate);
        }
        public static Int16 Init(int slot)
        {
            Int16 ret = ICPDAS.pac_i8172W_Init(slot);
            return ret;
        }
        public static void WriteDOGroup(int iSlot, int iPort, int iGroup, UInt16 iData)
        {
            ICPDAS.pac_i8172W_WriteDOGroup(iSlot, iPort, iGroup, iData);
        }
        public static void DIO_WriteDOBit(int iSlot, int iPort, int iGroup, int iChannel, int iStatus)
        {
            ICPDAS.pac_i8172W_DIO_WriteDOBit(iSlot, iPort, iGroup, iChannel, iStatus);
        }
        public static void DIO_WriteDOGroup(int iSlot, int iPort, int iGroup, UInt16 iData)
        {
            ICPDAS.pac_i8172W_DIO_WriteDOGroup(iSlot, iPort, iGroup, iData);
        }
        public static void WriteDOBit(int iSlot, int iPort, int iGroup, int iChannel, int iStatus)
        {
            ICPDAS.pac_i8172W_WriteDOBit(iSlot, iPort, iGroup, iChannel, iStatus);
        }
        public static UInt16 ReadDIGroup(int iSlot, int iPort, int iGroup)
        {
            return ICPDAS.pac_i8172W_ReadDIGroup(iSlot, iPort, iGroup);
        }
        public static UInt16 ReadDIBit(int iSlot, int iPort, int iGroup, int iChannel)
        {
            return ICPDAS.pac_i8172W_ReadDIBit(iSlot, iPort, iGroup, iChannel);
        }
        public static Int16 ReadDIGroupstatus(int iSlot, int iPort, int iGroup)
        {
            return ICPDAS.pac_i8172W_ReadInputGroupStatus(iSlot, iPort, iGroup);
        }
        public static Int16 ReadInputGroupStatus(int iSlot, int iPort, int iGroup)
        {
            return ICPDAS.pac_i8172W_ReadInputGroupStatus(iSlot, iPort, iGroup);
        }
        public static UInt16 DIO_ReadDIGroup(int iSlot, int iPort, int iGroup)
        {
            return ICPDAS.pac_i8172W_DIO_ReadDIGroup(iSlot, iPort, iGroup);
        }
        public static UInt16 DIO_ReadDIBit(int iSlot, int iPort, int iGroup, int iChannel)
        {
            return ICPDAS.pac_i8172W_DIO_ReadDIBit(iSlot, iPort, iGroup, iChannel);
        }
        public static Int16 ReadAIHex(int iSlot, int iPort, int iGroup, short bitMode, ref Int16 chIndex, ref Int16 aiHex)
        {
            return ICPDAS.pac_i8172W_ReadAIHex(iSlot, iPort, iGroup, bitMode, ref chIndex, ref aiHex);
        }
        public static void AIHexToFloat(Int16 hexData, Int16 typeCode, Int16 bitMode, ref float fData)
        {
            ICPDAS.pac_i8172W_AIHexToFloat(hexData, typeCode, bitMode, ref fData);
        }
        public static Int16 ReadAI_Ch(int iSlot, int iPort, int iGroup, short bitMode, Int16 typeCode, Int16 chIndex, ref float aiFloat)
        {
            return ICPDAS.pac_i8172W_ReadAI_Ch(iSlot, iPort, iGroup, bitMode, typeCode, chIndex, ref aiFloat);
        }
        public static Int16 ReadAI_All(int iSlot, int iPort, int iGroup, short bitMode, short isSingleEnded, short[] typeCode, float[] aiFloat)
        {
            return ICPDAS.pac_i8172W_ReadAI_All(iSlot, iPort, iGroup, bitMode, isSingleEnded, typeCode, aiFloat);
        }
        public static Int16 WriteAOHex(int iSlot, int iPort, int iGroup, short bitMode, short iChannel, short aoHexData, short ifDelay)
        {
            return ICPDAS.pac_i8172W_WriteAOHex(iSlot, iPort, iGroup, bitMode, iChannel, aoHexData, ifDelay);
        }
        public static Int16 WriteAOFloat(int iSlot, int iPort, int iGroup, short bitMode, short iChannel, short typeCode, float aoFloat, short ifDelay)
        {
            return ICPDAS.pac_i8172W_WriteAOFloat(iSlot, iPort, iGroup, bitMode, iChannel, typeCode, aoFloat, ifDelay);
        }
        private static string AscArr2Str(byte[] b)
        {
            return System.Text.UnicodeEncoding.Unicode.GetString(
            System.Text.ASCIIEncoding.Convert(System.Text.Encoding.ASCII,
            System.Text.Encoding.Unicode, b), 0, b.Length);
        }
        public static string Arr2Str(byte[] buffer)
        {
            return (new UnicodeEncoding()).GetString(buffer, 0, buffer.Length);
        }
    }
}