﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.UI;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x404

namespace i8172W_FRNET_Modules_Csharp
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        Int16 slot=-1;
        public MainPage()
        {
            this.InitializeComponent();
            Library_ver_txt.Text = String.Format("{0:X4}", pac8172WNet.pac8172W.LibVersion());
            Library_date_txt.Text = pac8172WNet.pac8172W.LibDate();
        }

        private void slot_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            int ret = -1;
            slot = (Int16)slot_cbx.SelectedIndex;
            ret = pac8172WNet.pac8172W.Init(slot);
            if (ret == 0)
            {
                Status_txt.Text = "Init OK!!";
            }
            else
            {
                Status_txt.Text = "Init Failed!!";
            }
        }

        private void Read_2017_btn_Click(object sender, RoutedEventArgs e)
        {
            ComboBox[] Type_cbx = new ComboBox[16] {
                T0_2017_cbx, T1_2017_cbx, T2_2017_cbx, T3_2017_cbx, T4_2017_cbx, T5_2017_cbx, T6_2017_cbx, T7_2017_cbx,
                T8_2017_cbx, T9_2017_cbx, T10_2017_cbx, T11_2017_cbx, T12_2017_cbx, T13_2017_cbx, T14_2017_cbx, T15_2017_cbx
            };
            TextBox[] AI_txt = new TextBox[16] {
                AI0_2017_txt ,AI1_2017_txt ,AI2_2017_txt ,AI3_2017_txt ,AI4_2017_txt ,AI5_2017_txt ,AI6_2017_txt ,AI7_2017_txt ,
                AI8_2017_txt ,AI9_2017_txt ,AI10_2017_txt ,AI11_2017_txt ,AI12_2017_txt ,AI13_2017_txt ,AI14_2017_txt ,AI15_2017_txt
            };
            int i = 0;
            int bitMode = 0;
            int max_ch = 0;
            short typecode = 0;
            float fval = 0;
            if (SING_DIFF_2017_cbx.SelectedIndex == 0)
            {
                max_ch = 8;
            }
            else
            {
                max_ch = 16;
            }
            if (Bits_2017_cbx.SelectedIndex == 0)
            {
                bitMode = 12;
            }
            else
            {
                bitMode = 16;
            }
            for (i = 0; i < max_ch; ++i)
            {
                if (Type_cbx[i].SelectedIndex != 7)
                {
                    typecode = (short)(Type_cbx[i].SelectedIndex + 7);
                }
                else
                {
                    typecode = 0x1a;
                }
                pac8172WNet.pac8172W.ReadAI_Ch(slot, P2017_cbx.SelectedIndex, (G2017_cbx.SelectedIndex + 8), (short)bitMode, typecode, (short)i, ref fval);
                AI_txt[i].Text = fval.ToString();
            }
        }

        private void AO_2024_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            Int16 typeCode = 0;
            Int16 bitMode = 12;
            ComboBox[] Type_cbx = { T0_2024_cmb, T1_2024_cmb, T2_2024_cmb, T3_2024_cmb };
            TextBox[] AO_txt = new TextBox[] { AO0_2024_txt, AO1_2024_txt, AO2_2024_txt, AO3_2024_txt };
            Button[] AO_btn = new Button[4] { C0_2024_btn, C1_2024_btn, C2_2024_btn, C3_2024_btn };
            Button btn = sender as Button;
            for (i = 0; i < 4; ++i)
            {
                if (btn.Name == AO_btn[i].Name)
                {
                    ch = i;
                    break;
                }
            }
            typeCode = (Int16)(Type_cbx[ch].SelectedIndex + 0x30);
            pac8172WNet.pac8172W.WriteAOFloat(slot, P2024_cbx.SelectedIndex, G2024_cbx.SelectedIndex, bitMode, ch, typeCode, float.Parse(AO_txt[ch].Text), 0);
        }

        private void Read_2053_btn_Click(object sender, RoutedEventArgs e)
        {
            int i = 0;
            TextBox[] DIBit_txt = new TextBox[16] {
                DI0_2053_txt, DI1_2053_txt, DI2_2053_txt, DI3_2053_txt, DI4_2053_txt, DI5_2053_txt, DI6_2053_txt, DI7_2053_txt,
                DI8_2053_txt, DI9_2053_txt, DI10_2053_txt, DI11_2053_txt, DI12_2053_txt, DI13_2053_txt, DI14_2053_txt, DI15_2053_txt
            };
            for (i = 0; i < 16; ++i)
            {
                if (pac8172WNet.pac8172W.ReadDIBit(slot, P2053_cbx.SelectedIndex, G2053_cbx.SelectedIndex + 8, i) == 0)
                {
                    DIBit_txt[i].Text = "OFF";
                    DIBit_txt[i].Background = new SolidColorBrush(Colors.MediumVioletRed);
                }
                else
                {
                    DIBit_txt[i].Text = "ON";
                    DIBit_txt[i].Background = new SolidColorBrush(Colors.LightGreen);
                }
            }
        }

        private void Read_2054_btn_Click(object sender, RoutedEventArgs e)
        {
            int i = 0;
            TextBox[] DIBit_txt = new TextBox[8] { DI0_2054_txt, DI1_2054_txt, DI2_2054_txt, DI3_2054_txt, DI4_2054_txt, DI5_2054_txt, DI6_2054_txt, DI7_2054_txt };
            for (i = 0; i < 8; ++i)
            {
                if (pac8172WNet.pac8172W.ReadDIBit(slot, P2054_cbx.SelectedIndex, G2054_cbx.SelectedIndex, i) == 0)
                {
                    DIBit_txt[i].Text = "OFF";
                }
                else
                {
                    DIBit_txt[i].Text = "ON";
                }
            }
        }

        private void DO_2054_ckx_Click(object sender, RoutedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            CheckBox[] DOBit_ckx = new CheckBox[8] { C0_2054_ckx, C1_2054_ckx, C2_2054_ckx, C3_2054_ckx, C4_2054_ckx, C5_2054_ckx, C6_2054_ckx, C7_2054_ckx };
            CheckBox ckx = sender as CheckBox;
            for (i = 0; i < 8; ++i)
            {
                if (ckx.Name == DOBit_ckx[i].Name)
                {
                    ch = i;
                    break;
                }
            }
            if (ckx.IsChecked == true)
            {
                pac8172WNet.pac8172W.DIO_WriteDOBit(slot, P2054_cbx.SelectedIndex, G2054_cbx.SelectedIndex, ch, 1);
            }
            else
            {
                pac8172WNet.pac8172W.DIO_WriteDOBit(slot, P2054_cbx.SelectedIndex, G2054_cbx.SelectedIndex, ch, 0);
            }
        }

        private void DO_2057_ckx_Click(object sender, RoutedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            CheckBox[] DOBit_ckx = new CheckBox[16] {
                C0_2057_ckx, C1_2057_ckx, C2_2057_ckx, C3_2057_ckx, C4_2057_ckx, C5_2057_ckx, C6_2057_ckx, C7_2057_ckx ,
                C8_2057_ckx, C9_2057_ckx, C10_2057_ckx, C11_2057_ckx, C12_2057_ckx, C13_2057_ckx, C14_2057_ckx, C15_2057_ckx
            };
            CheckBox ckx = sender as CheckBox;
            for (i = 0; i < 16; ++i)
            {
                if (ckx.Name == DOBit_ckx[i].Name)
                {
                    ch = i;
                    break;
                }
            }
            if (ckx.IsChecked == true)
            {
                pac8172WNet.pac8172W.WriteDOBit(slot, P2057_cbx.SelectedIndex, G2057_cbx.SelectedIndex, ch, 1);
            }
            else
            {
                pac8172WNet.pac8172W.WriteDOBit(slot, P2057_cbx.SelectedIndex, G2057_cbx.SelectedIndex, ch, 0);
            }
        }

        private void Exit_btn_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Exit();
        }
    }
}